import { AccessLevelList } from "../shared/access-level";
import { PolicyStatement } from "../shared";
import { PolicyStatementProps } from "@aws-cdk/aws-iam";
/**
 * (experimental) Statement provider for service [marketplacecommerceanalytics](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsmarketplacecommerceanalyticsservice.html).
 *
 * @experimental
 */
export declare class Marketplacecommerceanalytics extends PolicyStatement {
    /**
     * (experimental) Holds the prefix of the service actions, e.g. `ec2`.
     *
     * @experimental
     */
    servicePrefix: string;
    /**
     * (experimental) Request a data set to be published to your Amazon S3 bucket.
     *
     * Access Level: Write
     *
     * @experimental
     */
    toGenerateDataSet(): this;
    /**
     * (experimental) Request a support data set to be published to your Amazon S3 bucket.
     *
     * Access Level: Write
     *
     * @experimental
     */
    toStartSupportDataExport(): this;
    /**
     * @experimental
     */
    protected accessLevelList: AccessLevelList;
    /**
     * (experimental) Statement provider for service [marketplacecommerceanalytics](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsmarketplacecommerceanalyticsservice.html).
     *
     * @experimental
     */
    constructor(props?: PolicyStatementProps);
}
