import iam = require('@aws-cdk/aws-iam');
import { PolicyStatementWithPrincipal } from './6-principals';
/**
 * (experimental) Adds CDK specific "principal" functionality to the Policy Statement.
 *
 * @experimental
 */
export declare class PolicyStatementWithCDKPrincipal extends PolicyStatementWithPrincipal {
    /**
     * @experimental
     */
    protected cdkPrincipals: iam.IPrincipal[];
    private cdkPrincipalsApplied;
    /**
     * (experimental) Adds any number of CDK principals to the statement.
     *
     * @param principals Principals to add to the statement.
     * @experimental
     */
    forCdkPrincipal(...principals: iam.IPrincipal[]): this;
    /**
     * @experimental
     */
    protected cdkApplyPrincipals(): void;
}
